;Watcom C/C++ versions 9.5 and 10.0.
;INT 33h function 0Ch

.486P

INCLUDE STRUCT.INC
INCLUDE COSTANT.INC

;------------------------------- START UP ---------------------------------
;
;		EAX = 00000000			CS = SelStart
;		EBX = 00000000                  DS = SelPSP
;		ECX = 00000000			ES = SelInfo
;		EDX = 00000000                  FS = SelStart_Data
;		EBP = 00000000                  GS = SelStart_Data
;		ESI = 00000000                  SS = SelStack
;		EDI = 00000000
; 		EFLAGS = 000011000000000010b   < -- IO PL = 3
;				 	       < -- NT    = 0
; 		ESP = points to empty stacktop
;	 	EIP = Start
;

;----------------------------- Protected Mode --------------------------------
;
;	 SelInfo          [ROM]       // Descrittore Informazioni
;	 StartTSS		      // Descrittore Task
;	 SelPSP           [ROM]	      // Descrittore PSP
;	 SelStart                     // Descrittore Start Code
;	 SelStart_Data                // Descrittore Start Data
;	 SelFlat                      // Descrittore Flat Model
;	 SelLowMem                    // Descrittore Memoria bassa
;	 SelXmsMem                    // Descrittore Memoria alta
;	 SelCharMap                   // Descrittore Tabella caratteri
;  	 Sel_VGA_Text                 // Descrittore Vga Testo
;	 Sel_VGA_13                   // Descrittore Vga 320*200
;	 SelSvga		      // Descrittore Svga (INIT & INIT_RES)
;        SelInfo:LOW_FREE_MEM	  32  // Memoria bassa libera (32 bit).
;	 SelInfo:LOW_START_MEM    32  // Inizio memoria bassa.
;	 SelInfo:XMS_FREE_MEM	  32  // Memoria XMS libera (32 bit).
;	 SelInfo:XMS_START_MEM	  32  // Inizio memoria alta.
;	 SelInfo:VENDOR_ID  	12*8  // Nome del processore.
;	 SelInfo:CPU_TYPE	   8  // Tipo del processore.
;	 SelInfo:INTEL_PROC	   8  // 1 se il processore  Intel.
;	 SelInfo:Svga_Mem	  32  // Memoria video      (SVGA_INIT)
;	 SelInfo:Svga_VH	   8  // Versione VBE High  (SVGA_INIT)
;	 SelInfo:Svga_VL           8  // Versione VBE low   (SVGA_INIT)
;
;
;
;------------------------------- Real Mode -----------------------------------
;
;
;	 Kernel_Data	  [ROM]	      // Segmento Info
;	 Kernel_Code	  [ROM]       // Segmento Codice Kernel
;	 Kernel_Data:PSP  [ROM]	      // locazione contente l'indirizzo del
;				      // PSP.
;	 Kernel_Data:LOW_FREE_MEM  32 // Memoria bassa libera (32 bit).
;        Kernel_Data:LOW_START_SEG 32 // Segmento di inizio memoria bassa.
;	 Kernel_Data:XMS_FREE_MEM  32 // Memoria XMS libera (32 bit).
;	 Kernel_Data:XMS_START_MEM 32 // Inizio memoria alta.
;	 Kernel_Data:VENDOR_ID   12*8 // Nome del processore.
;	 Kernel_Data:CPU_TYPE	    8 // Tipo del processore.
;	 Kernel_Data:INTEL_PROC	    8 // 1 se il processore  Intel.
;	 Kernel_Data:Svga_Mem	   32 // Memoria video      (SVGA_INIT)
;	 Kernel_Data:Svga_VH	    8 // Versione VBE High  (SVGA_INIT)
;	 Kernel_Data:Svga_VL        8 // Versione VBE low   (SVGA_INIT)
;
;
;
;----------------------- System Softaware Interrupt --------------------------
;
;		 INT 48 - Termina
;		        INPUT :
;                            AL = Ret_Code
;
;
;		 INT 49 - Create new Desc
;			INPUT :
;			     EAX = 32 bit BASE
;			     EBX = 24 bit Limit + Prop
;			     CL  = Access rights
;			OUTPUT :
;			     EAX = 16 bit Selettore con DPL 0.
;			     EAX = 0 on Error.
;
;
;		 INT 50 - Real Calling
;			INPUT :
; 			     EBX = Offset di destinazione
;			     EDX = Segmento di destinazione
;			In Function :
;
;	 EAX =  Modified			CS = SEG Funzione 16
;	 EBX =  Old	 			DS = Flat Model   32 (Saved)
; 	 ECX =  Old				ES = Flat Model   32 (Saved)
;	 EDX =  Old                             GS = Flat Model   32 (Saved)
; 	 EBP =  Old				FS = Protetto     16 (Saved)
; 	 ESI =  Old				SS = Real Stack	  16 (Saved)
; 	 EDI =  Old
; 	 EFLAGS = Old flag - NT
; 	 ESP =  Stack top
; 	 EIP =  OFFSET Funzione 16
;
;		486 CLOCKS = 605 totale
;		537 773 volte al secondo su 133 Mhz
;
;        OUTPUT (Change from Real) : EAX, ESP, All segment register
;        OUTPUT (Change from PM)   : EAX, all general register change in RM.
;
; N.B. :   +) Non entrarci con IF = 0 da lungo tempo.
;	   +) Non diabilitare Keyboard dal RM2PM_PIC.
;	   +) In RM lasciare IF = 1 (Auto).
;
;
;
;
;
;		 INT 51 - PIC Setting
;			INPUT :
;			     AL = 0 Set PM
; 				  1 Set RM2PM
;			     BL = PIC1
; 			     BH = PIC2
;			OUTPUT : Modifica EAX
;
;
;
; -------------------------- Device Softaware Interrupt ------------------------
;
;		 INT 52 - Getch
; 			OUTPUT : AL = Tasto
;
;
;		 INT 53 - KbHit
; 			OUTPUT : EAX = Num Caratteri in buffer
;
;
;		 INT 54 - Cout
;			INPUT  : DS:ESI = Stringa
; 			OUTPUT : Modifica ESI
;
;
;		 INT 55 - Locate
;			INPUT  : AH = X , AL = Y
; 			OUTPUT : Modifica EAX
;
;
;		 INT 56 - GraphTxt
;			INPUT  :
;			     DH = Color
;       		     DS:ESI Stringa
;			     ES:EDI Output Point
; 			OUTPUT : Modifica DX, ESI, EDI
;
;
;		 INT 57 - SvgaInit
;			OUTPUT : AL = 0	 OK
;                                     1  Errore
; 				 Modifica : EAX,EBX,ECX,EDX,ESI,EDI
;
;
; Kernel_Code:SvgaSetLinerar_Buffer
;			INPUT : EAX = Linear Address of Svga Buffer
;			OUTPUT : Modifica EAX
;
;


;  outp (0x3c8, 0);

;  for (pcount=0; pcount<768; pcount+=3)
;  {
;    outp (0x3c9, palp[pcount]);
;    outp (0x3c9, palp[pcount+1]);
;    outp (0x3c9, palp[pcount+2]);
;  }



Start_SEG 	SEGMENT PUBLIC USE32 'CODE'
		ASSUME CS:Start_SEG,DS:Start_Data

Start_Limit_Low	EQU $

Start:					      ; your code comes here
		STI			      ; better put it but there are
					      ; the safer.

		int 57
		INT 52

		mov ecx,0
		mov ebx,offset Real_Init	; 537 773 volte al secondo
		mov edx,SEG REAL_SEG		; su 133 Mhz
		INT 50


		INT 52
		MOV EAX,SelSvga
		MOV ES,EAX
		XOR EDI,EDI
		XOR EAX,EAX
		MOV ESI,50

		jmp op_12
OP2:		MOV ECX,640*480               ; 83,5 Mbytes/sec
OP:		STOSB
		INC EAX
		DEC ECX
		JNZ SHORT OP
		XOR EDI,EDI
		INC EAX
		DEC ESI
		JNZ SHORT OP2

		INT 52
op_12:
		XOR EBX,EBX
		MOV ECX,20

A_P:		MOV AL,0CH
		MOV EDX,3D4H
		OUT DX,AL
		INC DL
		MOV AL,BH
		OUT DX,AL

		MOV AL,0DH
		DEC DL
		OUT DX,AL
		INC DL
		MOV AL,BL
		OUT DX,AL


		INT 52

		INC EBX
		DEC ECX

		JNZ SHORT A_P

		INT 52
		mov ecx,1
		mov ebx,offset Real_Init	; 537 773 volte al secondo
		mov edx,SEG REAL_SEG		; su 133 Mhz
		INT 50

		MOV AL,0
		int 48

Start_Limit	EQU $ - Start_Limit_Low - 1

Start_SEG 	ENDS




Start_Data	SEGMENT PUBLIC 8 USE32 'DATA'

StartData_Limit_Low	EQU	$
		DB	1000 dup (0)

StartData_Limit         EQU $ - StartData_Limit_Low - 1

Start_Data	ENDS



EXTRN 		@C_Main$qv:NEAR

REAL_SEG 	SEGMENT PUBLIC USE16 'CODE'
		ASSUME CS:REAL_SEG,DS:REAL_DATA,SS:REAL_DATA
		ASSUME ES:NOTHING,FS:NOTHING,GS:NOTHING


Real_Init:
		CMP CX,0
		JNE SHORT RES

	MOV AX,SS
	MOV ES,AX
	SUB SP,256
	MOV DI,SP

	mov ax,4F01h
	mov cx,100h
	int 10h

	mov ax,4F02h
	mov bx,0C101h
	int 10h

	mov eAX,dword ptr es:[DI+28h]
	ADD SP,256
	push eax

	CALL Kernel_Code:SvgaSetLinerar_Buffer

	pop eax
	MOV EDI,eax
	MOV AX,CS
	MOV DS,AX
	MOV DX,OFFSET Nome
							; DS:DX Nome
	CALL Read_File                                  ; EDI DEST


	RETF
Nome	db	'1.pix',0

RES:		MOV AX,3
		INT 10H
		RETF



Read_File	PROC NEAR			; AX, ECX, BX,dx,ESI,EDI
						; ECX =BYTES LETTI
	PUSH DS
	PUSH ES
	XOR ECX,ECX
	MOV AX,3D00H
	INT 21H
	JC SHORT Error
	MOV BX,AX		        	; BX = Handle
	MOV AX,Kernel_Data
	MOV DS,AX

;	MOV DX,LOW_START_SEG

	MOV DX,SEG Start_Data	;PROBLEM
	MOV DS,DX
	XOR DX,DX                       	; DS:DX Buffer
	MOV ES,CX				; ES:EDI Dest
	PUSH ECX				; STACK Bytes letti

Rip_Lettura:

	MOV AH,3FH
	MOV CX,900
	INT 21H
	MOVZX EAX,AX				; EAX bytes letti
	MOV ECX,EAX
	SHR ECX,2				; ECX DWORD Lette

	XOR ESI,ESI                             ; DS:0000 -> ES:EDI
	REP
	DB 67H
	MOVSD

	POP ECX
	ADD ECX,EAX
	PUSH ECX
	CMP AX,900
	JE SHORT Rip_Lettura

	MOV AH,3EH
	INT 21H
	POP ECX
Error:
	POP ES
	POP DS
	RET

Read_File	ENDP




REAL_SEG 	ENDS

REAL_DATA 	SEGMENT PUBLIC USE16 'DATA'
		; GLOBAL DATA

_Pointer 	DB	'Ciao sono luca',0

Stack		DW	13000 DUP (0)
REAL_DATA 	ENDS

public 		_Pointer
END
